<?php

namespace App\Sets\Model;

use \Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\Relation;
use Illuminate\Support\Facades\DB;

class Sets extends Model
{
    use \App\Traits\Models;
    const SHELF_UP  = 0;
    const SHELF_DOWN = 1;
    protected $table = "myp_sets";
    public $timestamps = false;

    public function __construct(array $attributes)
    {
        parent::__construct($attributes);
        $this->beforeValidationOnCreate();
    }

    public function beforeValidationOnCreate()
    {
        $this->collect_count = 0;
        $this->star = 0;
        $this->star_count = 0;
        $this->look_count=0;
        $this->makeup_descr = "";
        $this->scene_descr = "";
        $this->use_score = 0;
        $this->cost_count = 0;
        $this->n_lock = 0;
        $this->n_sale = 0;
        $this->n_total_sale = 0;
        $this->promotion_id = 0;
        $this->total_sale = 0;
        $this->p_lock = 0;
        $this->create_time = date("Y-m-d H:i:s",time());
        $this->is_del = 0;
        $this->sort = 0;
    }

    public function relation_promotion()
    {
        return $this->hasMany(Promotion::class,"sets_id")->where('is_del',0);
    }

    public function relation_attatchment()
    {
        return $this->hasMany(Attachment::class,"sets_id")->where('is_del',0);
    }

    public function relation_works()
    {
        return $this->hasMany(Works::class,"sets_id")->where('is_del',0)->select(['works_id']);
    }

    public function relation_keywords()
    {
        return $this->hasMany(Keywords::class,"sets_id")->where('is_del',0)->select(Keywords::fields);
    }

    public function relation_category()
    {
        return $this->hasMany(Category::class,"sets_id")->where('is_del',0)->select(Category::fields);
    }

    public function relation_comments()
    {
        return $this->hasMany(Comments::class,"sets_id")->where('is_del',0);
    }


    public static function newSets($data)
    {
        DB::beginTransaction();

    }

    public function uptSets($data)
    {

    }
}