<?php

namespace App\Traits;

trait Controller
{
    /**
     * 筛选合法参数
     * @param $where
     * @return \__|array
     * @throws \Exception
     */
    public function filter($where)
    {
        require __DIR__."/../Functions/underscore.php";
        $query_fields = null;
        isset($this->query_fields) && $query_fields = $this->query_fields;
        is_string($query_fields) && $query_fields = [$query_fields];
        if ($query_fields)
        {
            if (trim($query_fields[0]) == "*") {
                return $where;
            }
            return __()->pick($where,__()->intersection($this->query_fields,__()->keys($where)));
        }
        return $where;
    }

    public function setBlurSearch($where,$key,$condition = "eq")
    {
        if (is_null($where)) {
            return null;
        }
        if (!in_array($key,array_keys($where))) {
            return $where;
        }
        switch ($condition) {
            case "eq":
                $where["_condition"] = [$key,"like","'%.$where[$key].%'"];
                break;
            case "elt":
                $where["_condition"] = [$key,"<=","'$where[$key]'"];
                break;
            case "lt":
                $where["_condition"] = [$key,"<","'$where[$key]'"];
                break;
            case "gt":
                $where["_condition"] = [$key,"<","'$where[$key]'"];
                break;
            case "egt":
                $where["_condition"] = [$key,">=","'$where[$key]'"];
                break;
        }
        return $where;
    }

    public function csrf($data,$key) {
       return preg_replace("/<script[^>]*>.*<\/script>/i","",$data[$key]);
    }
}